## pd-faust-0.9.tar.gz

=== Makefile ===

# This is a GNU makefile. Please also check Makefile.config for customizable
# setup information and Makefile.common for the actual compilation rules.

# Normally you just run 'make' and then 'make install' to build and install
# the package. The usual standard targets to clean (clean, distclean,
# realclean) and roll a distribution tarball (dist, distcheck) are supported
# as well. 'make install' also honors DESTDIR so that staged installs can be
# done conveniently by package maintainers.

# Installation goes to extra/faust in your Pd library directory by default.
# The Makefile tries to detect the location of your Pd installation. You can
# change this by setting any of the prefix, libdir, pdlibdir and pdextradir
# variables on the command line, see below for the defaults.

# If you'd like to experiment with Faust bitcode modules which can be loaded
# natively by the Pure interpreter, you also need to run 'make bitcode' before
# 'make install'. Please check pdfaust.pure for details.

include Makefile.config

# Package name and version:
dist = pd-faust-$(version)
version = 0.9

DISTFILES = COPYING COPYING.LESSER Makefile Makefile.config.in Makefile.config \
Makefile.common README TODO config.guess *.pure etc/*.el etc/*.pd \
debian/* examples/*.pd examples/midi/*.mid examples/osc/*.osc \
examples/dsp/README* examples/dsp/Makefile \
examples/dsp/*.dsp examples/dsp/*.lib examples/dsp/*.h \
lib/Makefile lib/*.c lib/*.dsp lib/*.pure pd/*.h
SEDFILES = README

subdirs = lib examples/dsp

all:
	for x in $(subdirs); do $(MAKE) -C $$x PUREC_FLAGS="$(PUREC_FLAGS)" all; done

bitcode:
	for x in $(subdirs); do $(MAKE) -C $$x PUREC_FLAGS="$(PUREC_FLAGS)" bitcode; done

clean:
	for x in $(subdirs); do $(MAKE) -C $$x clean; done

distclean:
	for x in $(subdirs); do $(MAKE) -C $$x distclean; done

realclean:
	for x in $(subdirs); do $(MAKE) -C $$x realclean; done

install:
	test -d "$(DESTDIR)$(pdextradir)" || mkdir -p "$(DESTDIR)$(pdextradir)"
	cp COPYING COPYING.LESSER README TODO *.pure examples/*.pd etc/*.el lib/pdfaust*$(PDDLL) "$(DESTDIR)$(pdextradir)"
	cp -R examples/dsp examples/midi examples/osc "$(DESTDIR)$(pdextradir)"
	test -d "$(DESTDIR)$(pdextradir)/lib" || mkdir -p "$(DESTDIR)$(pdextradir)/lib"
	cp lib/util.* lib/xfade.* "$(DESTDIR)$(pdextradir)/lib"

uninstall:
	rm -rf "$(DESTDIR)$(pdextradir)"

Makefile.config: Makefile.config.in Makefile
	sed -e "s?@version@?$(version)?g" < $< > $@

date = $(shell date "+%B %-d, %Y")
datesubst = sed -e "s?@version@?$(version)?g" -e "s?|today|?$(date)?g" < $(1) > $(2)

dist:
	rm -rf $(dist)
	for x in $(dist) $(addprefix $(dist)/, debian etc lib pd examples $(addprefix examples/, dsp midi osc)); do mkdir $$x; done
	for x in $(DISTFILES); do ln -sf "$$PWD"/$$x $(dist)/$$x; done
	for x in $(SEDFILES); do rm -f $(dist)/$$x; $(call datesubst,"$$PWD"/$$x,$(dist)/$$x); done
	rm -f $(dist).tar.gz
	tar cfzh $(dist).tar.gz $(dist)
	rm -rf $(dist)

distcheck: dist
	tar xfz $(dist).tar.gz
	cd $(dist) && make && make install DESTDIR=./BUILD
	rm -rf $(dist)

debsrc = $(shell echo $(dist) | sed -e 's/-$(version)/_$(version)/').orig.tar.gz

deb: $(debsrc) dist
	tar xfz $(dist).tar.gz
	cd $(dist) && debuild $(DEBUILD_FLAGS)
	rm -rf $(dist)

$(debsrc):
	wget -nv https://bitbucket.org/purelang/pure-lang/downloads/$(dist).tar.gz -O $@

=== lib/Makefile ===

override srcdir = ..
include $(srcdir)/Makefile.common

override CPPFLAGS += -I$(pdincdir) -I../pd

solibs     := util$(DLL) pdstub$(DLL)
somodules  := $(dsp_source:.dsp=$(DLL))
bcmodules  := $(dsp_source:.dsp=.bc)

# The xfade dsp is needed by all effect plugins, preallocate some units.
$(somodules): CXXFLAGS += -DNVOICES=16

all: $(solibs) $(somodules) pdfaust$(PDDLL)
bitcode: $(bclibs) $(bcmodules) pdfaust2$(PDDLL)

# We need the location of some of the installed Pure library modules.
purelib = $(shell pkg-config pure --variable libdir)/pure

# pure-faust precompiled module.

ifneq "$(findstring -darwin,$(host))" ""
# OSX doesn't have -rpath, so we have to rely on that the proper load path is
# set when the libraries are linked. Also note that we need the -undefined
# dynamic_lookup linker flag here to link back into the Pd executable.
extralibs = -Wl,-undefined -Wl,dynamic_lookup $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL))
else ifneq "$(findstring -mingw,$(host))" ""
# Windows requires linking against the Pd library and the Pure plugin loader.
extralibs = -Wl,--enable-auto-import $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL)) $(libdir)/$(PD)/extra/pure/pure.dll -lpd -lglob
else
# This requires a linker that handles the -rpath option. Otherwise you may
# have to add the Pure library directory to your system dll search path so
# that the linked library modules are found when the pdfaust module is loaded
# by Pd.
extralibs = -Wl,-rpath=$(purelib) $(addprefix $(purelib)/, orddict$(DLL) faust$(DLL) midifile$(DLL))
endif

pdfaust$(PDDLL): pdfaust.o pdloader.o util.o
	rm -f pdfaust$(PDDLL)
	gcc $(PIC) $(shared) $^ $(extralibs) -o pdfaust$(DLL) $(PURE_LIBS)
	test "$(DLL)" = "$(PDDLL)" || mv pdfaust$(DLL) pdfaust$(PDDLL)

pdfaust2$(PDDLL): pdfaust2.o pdloader2.o util.o
	rm -f pdfaust2$(PDDLL)
	gcc $(PIC) $(shared) $^ $(extralibs) -o pdfaust2$(DLL) $(PURE_LIBS)
	test "$(DLL)" = "$(PDDLL)" || mv pdfaust2$(DLL) pdfaust2$(PDDLL)

pdfaustsrc = $(addprefix ../, fdsp~.pure fsynth~.pure midiseq.pure oscseq.pure)
pdfaustdeps = $(wildcard ../*.pure)

pdfaust.o: $(pdfaustdeps)
	pure $(PIC) $(PUREC_FLAGS) -I.. -L.. -c $(pdfaustsrc) -o $@ --main __pdfaust_main__

pdfaust2.o: $(pdfaustdeps)
	pure $(PIC) $(PUREC_FLAGS) -I.. -L.. -c $(pdfaustsrc) -o $@ --main __pdfaust_main__ --enable faust2

pdloader.o: pdloader.c
	gcc $(ALL_CFLAGS) -DVERSION="\"$(version)\"" -c $< -o $@

pdloader2.o: pdloader.c
	gcc $(ALL_CFLAGS) -DVERSION="\"$(version)\"" -DFAUST2 -c $< -o $@

util.o: util.c
	gcc $(ALL_CFLAGS) -c $< -o $@

# Faust-specific stuff
svg: $(svg)
xml: $(xml)

clean:
	rm -f $(solibs) $(somodules) $(bclibs) $(bcmodules) *.o pdfaust$(PDDLL) pdfaust2$(PDDLL)

distclean: clean
	rm -Rf $(csource) $(cppsource) $(asmsource) $(svg) $(xml)

realclean: distclean

=== examples/dsp/Makefile ===

override srcdir = ../..
include $(srcdir)/Makefile.common

somodules  := $(dsp_source:.dsp=$(DLL))
bcmodules  := $(dsp_source:.dsp=.bc)
modules    := $(somodules) $(bcmodules)

fx = amp.dsp chorus.dsp compressor.dsp echo.dsp expander.dsp flanger.dsp \
freeverb.dsp fuzz.dsp

fxmodules = $(fx:.dsp=.so)
synthmodules = $(filter-out $(fxmodules), $(somodules))

# uncomment this to debug voice allocation
#CXXFLAGS += -DDEBUG
# preallocate a suitable number of voices for the synths
$(synthmodules): CXXFLAGS += -DNVOICES=16

all: $(somodules)
bitcode: $(bcmodules)

$(synthmodules): instrument.lib

# Faust-specific stuff
svg: $(svg)
xml: $(xml)

clean:
	-rm -f $(modules)

distclean: clean
	rm -Rf $(csource) $(cppsource) $(asmsource) $(svg) $(xml)

realclean: distclean

=== debian/changelog ===
pd-faust (0.8-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Wed, 17 Sep 2014 00:36:11 +0200

pd-faust (0.7-2) trusty; urgency=low

  * Pass the -mcpu=generic option to llc when batch-compiling Pure
    scripts, to prevent illegal instructions depending on the build host's
    cpu type.

 -- Albert Graef <aggraef@gmail.com>  Mon, 15 Sep 2014 09:52:09 +0200

pd-faust (0.7-1) trusty; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Sat, 13 Sep 2014 23:17:37 +0200

pd-faust (0.5-1) precise; urgency=low

  * New upstream release

 -- Albert Graef <aggraef@gmail.com>  Thu, 19 Sep 2013 08:55:34 +0200

pd-faust (0.4-7) precise; urgency=low

  * Cosmetic changes (assume default samplerate of 44100 Hz)

 -- Albert Graef <Dr.Graef@t-online.de>  Tue, 29 Jan 2013 12:03:23 +0100

pd-faust (0.4-6) natty; urgency=low

  * Install extra Pd examples into lib/pd/extra/faust extra dir

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 14:11:24 +0200

pd-faust (0.4-5) natty; urgency=low

  * Dependency fixes

 -- Albert Graef <Dr.Graef@t-online.de>  Mon, 28 May 2012 00:58:53 +0200

pd-faust (0.4-4) natty; urgency=low

  * Faust 0.9.47 or later needed for building

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 22:13:57 +0200

pd-faust (0.4-3) natty; urgency=low

  * Add missing build dependency pkg-config

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 03:43:28 +0200

pd-faust (0.4-2) natty; urgency=low

  * Add missing build dependency llvm
  * Remove duplicate documentation files

 -- Albert Graef <Dr.Graef@t-online.de>  Sat, 26 May 2012 00:52:25 +0200

pd-faust (0.4-1) natty; urgency=low

  * Initial release

 -- Albert Graef <Dr.Graef@t-online.de>  Thu, 24 May 2012 23:52:49 +0200

=== debian/control ===
Source: pd-faust
Section: devel
Priority: extra
Maintainer: Albert Graef <aggraef@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), pure, pure-dev, pd-pure, pure-faust, pure-midi, pure-stldict, pkg-config, puredata, faust (>= 0.9.47) | faust2
Standards-Version: 3.9.1
Homepage: http://purelang.bitbucket.org

Package: pd-faust
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libpure8, pd-pure, pure-faust, pure-midi, pure-stldict
Suggests: faust (>> 0.9.46) | faust2
Description: Run Faust signal processors in Pd
 This package provides a dynamic environment for running Faust dsps in Pd,
 written in Pure. The basic functionality is somewhat similar to what the
 faust2pd script provides, but Faust units can be reloaded at any time, in
 which case their Pd GUIs are regenerated dynamically, inside Pd. It also
 supports MIDI and OSC controller mapping and controller automation. The
 package thus turns Pd into an interactive development environment for Faust,
 Grame's functional signal processing language.
 .
 Note: After installing the package, you still need to enable pd-faust in Pd.
 To these ends, add /usr/lib/pd/extra/faust to your Pd search path (under
 Preferences/Path in Pd) and add 'pdfaust' to your preloaded library modules
 (Preferences/Startup).
